#!/usr/bin/env python
# coding: utf-8

# In[1]:


import pandas as pd
import os

get_ipython().run_line_magic('load_ext', 'nb_black')


# In[3]:


smokedf = pd.read_csv(
    "california AQS speciation monitors linked to HMS 2006-2018 4-9-2021.csv"
)  # .set_index(["Date Local", "Local Site Name", "Parameter Name"])
firedf = pd.read_csv(
    "california AQS speciation monitors distance to closest fire 2006-2018.csv"
)


# In[4]:


index_cols = ["Date Local", "Latitude", "Longitude"]

smokedf = smokedf.drop_duplicates(subset=index_cols).set_index(index_cols)

firedf = firedf.drop_duplicates(subset=index_cols).set_index(index_cols)

hms_joined_df = firedf.join(smokedf["in_smoke?"]).reset_index()


# In[5]:


aqs_folder = "C:\\Users\\RRice\\OneDrive - Environmental Protection Agency (EPA)\\naaqs-fires data\\raw aqs data\\aqs_spec"

spec_2006_2018 = [
    "daily_SPEC_2006.csv",
    "daily_SPEC_2007.csv",
    "daily_SPEC_2008.csv",
    "daily_SPEC_2009.csv",
    "daily_SPEC_2010.csv",
    "daily_SPEC_2011.csv",
    "daily_SPEC_2012.csv",
    "daily_SPEC_2013.csv",
    "daily_SPEC_2014.csv",
    "daily_SPEC_2015.csv",
    "daily_SPEC_2016.csv",
    "daily_SPEC_2017.csv",
    "daily_SPEC_2018.csv",
]

aqs_spec = pd.concat([pd.read_csv(os.path.join(aqs_folder, x)) for x in spec_2006_2018])

aqs_spec = aqs_spec[aqs_spec["State Code"] == 6]


# In[6]:


aqs_spec.columns = [
    "State Code",
    "County Code",
    "Site Number",
    "Parameter Code",
    "POC",
    "Latitude",
    "Longitude",
    "Datum",
    "Parameter Name",
    "Sample Duration",
    "Pollutant Standard",
    "Date Local",
    "Units of Measure",
    "Event Type",
    "Observation Count",
    "Observation Percent",
    "Arithmetic Mean",
    "1st Max Value",
    "1st Max Hour",
    "AQI",
    "Method Code",
    "Method Name",
    "Local Site Name",
    "Address",
    "State Name",
    "County Name",
    "City Name",
    "CBSA Name",
    "Date of Last Change",
]


# In[7]:


join_cols = ["County Code", "Site Number", "Date Local"]  # removed POC

aqs_spec_hms_joined = aqs_spec.set_index(join_cols).join(
    hms_joined_df.set_index(join_cols)[["closest fire", "in_smoke?"]],
    how="left",
)


# In[8]:


aqs_spec_hms_joined.describe(include="all")


# In[11]:


aqs_spec_hms_joined.reset_index()


# In[9]:


join_cols = ["County Code", "Site Number", "POC", "Date Local"]

aqs_spec_hms_joined_poc = aqs_spec.set_index(join_cols).join(
    hms_joined_df.set_index(join_cols)[["closest fire", "in_smoke?"]],
    how="left",
)


# In[10]:


aqs_spec_hms_joined_poc.describe(include="all")


# In[12]:


export = aqs_spec_hms_joined[
    aqs_spec_hms_joined["Parameter Name"].str.contains("PM2.5 LC")
].reset_index()[
    [
        "State Code",
        "County Code",
        "Site Number",
        "POC",
        "Method Code",
        "Method Name",
        "Local Site Name",
        "Date Local",
        "Sample Duration",
        "Parameter Name",
        "Arithmetic Mean",
        "closest fire",
        "in_smoke?",
    ]
]

export.to_csv(
    "2006-2018 HMS smoke and fire analysis PM2.5 SPEC CA 11-3-2021.csv", index=False
)


# In[13]:


export.describe(include="all")


# In[ ]:




