#Testing related samples with missing values: a permutation approach
#https://pdf.sciencedirectassets.com/272524/1-s2.0-S0003347200X0022X/1-s2.0-S0003347299912460/main.pdf?X-Amz-Security-Token=IQoJb3JpZ2luX2VjEHgaCXVzLWVhc3QtMSJIMEYCIQCccUELrsaZBBdIJvTh3l9147To1izE1wvGdyW5Pv4GugIhALwX8hLeRg6A67Og8xRgDtHFIO32qOVxLACb%2BDIei0SZKr0DCMD%2F%2F%2F%2F%2F%2F%2F%2F%2F%2FwEQAxoMMDU5MDAzNTQ2ODY1IgyMjKK6YL%2B7rrp8fcEqkQM4LDs5lfHYK6WlJnaDtR9n1R4jA34DFyLbUSwKoSEBOS95ax5pcbn%2BZ%2F6RFiPQAztDv5HwA1mwUAZYwZdgaTg%2BPVp5xijPTr%2FWUrkaS1iNO%2FjVgKNiAqWuolyqkbKdFdkwagP4jA0B1HNZOp89nIo6UeleXlaw%2FWVZ5QrwyxV%2B6iu28qKYOkpxwToI6gyh5YvjP6iFlVooS6Fsn8lhvE8V7GM%2F43CPrY7ksOPe9Nwr245lTOr%2F%2Fdhbh1zPCLxayMNG1ljxdZWFWqCrj1kfDMdNyv3gXLSbNwOUZF%2BG58c0SsAAm4%2F8NKv%2FCJdmLwAckFXw7VWyToxW1ZbPqQW%2B6C5P3kCztOyrfUDMX8arZKjCtJKPfr6gMqNBKKlsmk5Z3OqBG%2BorcTWGLTnG2V8ZGP%2BVutdexqPuoMucjbPypOeTnU5vIYQBp%2FPROzIqBg%2FICO8nsObyhizVTC6sUEbqT%2BHpX%2BkRBXrqiivkYWQ2hSpWQ7cUmCWp3maXhBT7AyAL91%2Fb9%2F32%2B9soALyTuVz5kg3L7TCT55yDBjrqAUKrU%2BSzvze82mlVAuM7jQUajqTFZocRj%2FpR3QEgeK2sbH%2BpWkcLDC6bIf%2F0gp5UdXrN37B7SkHamD8WJOTb%2FfCAWWhlHQcXJ1Y02HzH0G7jBjr07A%2FbCNYL3AJkcoaeQ3iVIgMB7tLQeTRYVFve1hiASkgk4VViIb9MtASuRClxzHYGS0VCC4kwA7u65YQmm%2FaBgQm19DhyVXT7biUgy6ZMxjPVUhjPAiUnJqcTSi5fj5gor4cEgszuMr6pYhN0WG027M%2BgSp02hkYEgM%2BE1OgZwy%2BpvIzN49ZkQEl3Ssdn29NPSJBMYLheeg%3D%3D&X-Amz-Algorithm=AWS4-HMAC-SHA256&X-Amz-Date=20210402T161918Z&X-Amz-SignedHeaders=host&X-Amz-Expires=300&X-Amz-Credential=ASIAQ3PHCVTYVEQZL5F5%2F20210402%2Fus-east-1%2Fs3%2Faws4_request&X-Amz-Signature=5a8dd5c1e53b8a421b13741bcb8b2203ca085c90d519fa6e2e82c71a6996e983&hash=1a07f14176d9df248f073d4517e886f645939a213fee64699753e0aaa4898877&host=68042c943591013ac2b2430a89b270f6af2c76d8dfd086a07176afe7c76c2c61&pii=S0003347299912460&tid=spdf-86eb4e21-4b08-4f58-8430-cc9b694101eb&sid=d84079d05eee304bf33bdf23f6f04faf3ff7gxrqa&type=client

#setwd("C:/Users/KBoaggio/OneDrive - Environmental Protection Agency (EPA)/Wildfire data") 
setwd("C:/Users/KBoaggio/Environmental Protection Agency (EPA)/HAPs and fire - General/Data and code") 
library(permute)
library(plyr)
set.seed(123454321)

#> Read in data with aluminum data for all years and all sites.
aq.dat.og <- read.csv("2006-2020_combined_linkedtoplumes_data_2_15.csv") #"2006-2018_pm_speciation_labeled_new_11_3_21.csv",header=T)
matches = c("Potassium PM2.5 LC", "Iron PM2.5 LC", "Calcium PM2.5 LC", "Silicon PM2.5 LC", "Aluminum PM2.5 LC",
            "Zinc PM2.5 LC", "Titanium PM2.5 LC", "Manganese PM2.5 LC", "Chlorine PM2.5 LC", "Sodium PM2.5 LC",
            "Magnesium PM2.5 LC", "Strontium PM2.5 LC", "Copper PM2.5 LC", "Lead PM2.5 LC","Zirconium PM2.5 LC",
            "Phosphorus PM2.5 LC", "Vanadium PM2.5 LC", "Rubidium PM2.5 LC", "Benzene", "Selenium PM2.5 LC",
            "Chromium PM2.5 LC", "Acetaldehyde", "Formaldehyde", "Nickel PM2.5 LC", "Barium PM2.5 LC",
            "Tin PM2.5 LC", "Antimony PM2.5 LC", "Carbon tetrachloride", "Dichloromethane", "1,3-Butadiene", 
            "Cesium PM2.5 LC", "Cobalt PM2.5 LC", "Cadmium PM2.5 LC", "Indium PM2.5 LC", "Arsenic PM2.5 LC",
            "Chloroform", "Silver PM2.5 LC", "Cerium PM2.5 LC", "Tetrachloroethylene", "Acrolein - Unverified", 
            "Trichloroethylene", "Yttrium PM2.5 LC", "Mercury PM2.5 LC", "trans-1,3-Dichloropropene", 
            "cis-1,3-Dichloropropene", "Molybdenum PM2.5 LC", "Acrolein - Verified", "Lead PM10 STP", "Ethylene dichloride",
            "Lead (TSP) LC", "Lead (TSP) STP", "Lead PM10 LC FRM/FEM", 
            "Total Nitrate PM2.5 LC", "Ammonium Ion PM2.5 LC", "Chloride PM2.5 LC", "Bromine PM2.5 LC", "Sulfur PM2.5 LC", "Sulfate PM2.5 LC")
aq.dat.og <- aq.dat.og[grepl(paste(matches, collapse = "|"), aq.dat.og$Parameter.Name, ignore.case=TRUE),]

#> Make Type a factor
aq.dat.og$Type <- factor(aq.dat.og$Type,levels=c("Non-fire", "Fire"))

#> Create a unique site id (SS - CCC - NNNN - PPP)
aq.dat.og$site.id <- paste0(sprintf("%02d",aq.dat.og$State.Code),sprintf("%03d",aq.dat.og$County.Code),
                            sprintf("%04d",aq.dat.og$Site.Num),sprintf("%03d",aq.dat.og$POC))

#keeps <- c("Date","Parameter.Name", "Units.of.Measure", "Type", "site.id", "Year")
#aq.dat.og.2 = aq.dat.og[keeps]

#> Create list of elements and run for loop to create permutation index files
setwd("C:/Users/KBoaggio/Environmental Protection Agency (EPA)/HAPs and fire - General/Data and code/RData files - all fires")
mylist <- list("Potassium PM2.5 LC", "Iron PM2.5 LC", "Calcium PM2.5 LC", "Silicon PM2.5 LC", "Aluminum PM2.5 LC",
               "Zinc PM2.5 LC", "Titanium PM2.5 LC", "Manganese PM2.5 LC", "Chlorine PM2.5 LC", "Sodium PM2.5 LC",
               "Magnesium PM2.5 LC", "Strontium PM2.5 LC", "Copper PM2.5 LC", "Lead PM2.5 LC","Zirconium PM2.5 LC",
               "Phosphorus PM2.5 LC", "Vanadium PM2.5 LC", "Rubidium PM2.5 LC", "Benzene", "Selenium PM2.5 LC",
               "Chromium PM2.5 LC", "Acetaldehyde", "Formaldehyde", "Nickel PM2.5 LC", "Barium PM2.5 LC",
               "Tin PM2.5 LC", "Antimony PM2.5 LC", "Carbon tetrachloride", "Dichloromethane", "1,3-Butadiene", 
               "Cesium PM2.5 LC", "Cobalt PM2.5 LC", "Cadmium PM2.5 LC", "Indium PM2.5 LC", "Arsenic PM2.5 LC",
               "Chloroform", "Silver PM2.5 LC", "Cerium PM2.5 LC", "Tetrachloroethylene", "Acrolein - Unverified", 
               "Trichloroethylene", "Yttrium PM2.5 LC", "Mercury PM2.5 LC", "trans-1,3-Dichloropropene", 
               "cis-1,3-Dichloropropene", "Molybdenum PM2.5 LC", "Acrolein - Verified", "Lead PM10 STP", "Ethylene dichloride",
               "Lead (TSP) LC", "Lead (TSP) STP", "Lead PM10 LC FRM/FEM", 
               "Total Nitrate PM2.5 LC", "Ammonium Ion PM2.5 LC", "Chloride PM2.5 LC", "Bromine PM2.5 LC", "Sulfur PM2.5 LC", "Sulfate PM2.5 LC") #"Aluminum", "Potassium", "Calcium", "Total Nitrate", "Ammonium Ion", "Antimony", "Cerium", "Arsenic", "Barium", "Bromine", "Cadmium", "Calcium",  "Cesium", "Chloride", "Chlorine", "Chromium", "Cobalt", "Copper", "Indium", "Iron", "Lead", "Magnesium", "Manganese", "Mercury", "Molybdenum", "Nickel", "Phosphorus", "Potassium", "Rubidium", "Selenium", "Silicon", "Silver", "Sodium", "Strontium", "Sulfate", "Sulfur", "Tin", "Titanium", "Total Nitrate", "Vanadium", "Yttrium", "Zinc", "Zirconium")
mybiglist <- list()
for(i in mylist) {
  
  #> Choose specific element to run on
  print(i)
  aq.dat.in <- aq.dat.og[grepl(i, aq.dat.og$Parameter.Name, ignore.case=TRUE),]
  
  #> Species name and units
  species <- aq.dat.in$Parameter.Name[1]
  units <- aq.dat.in$Units.of.Measure[1]
  
  
  #> Set number of permuations for permuatation test.
  n.samples <- 10000
  
  #> Only have to run this code once.  Will save the ouput so that
  #> next time you can just load the shuffled indices rather than waiting for this long loop.
  run.permute <- TRUE
  
  if(run.permute){
    #> Time the loop.
    ptm0 <- proc.time()
    
    fire <- aq.dat.in[grepl('^Fire$', aq.dat.in$Type, ignore.case=TRUE),]
    years <- unique(fire$Year)
    years <- sort(years)
    
    for(YYYY in years){
    aq.dat.sub <- subset(aq.dat.in,Year==YYYY)
    aq.dat.sub <- aq.dat.in
    
    #> Drop  sites that do not have any fire days. 
    table.fire.data <- as.data.frame(table(aq.dat.sub$site.id,aq.dat.sub$Type))
    drop.sites <- as.character(table.fire.data$Var1[table.fire.data$Freq==0])
    aq.dat <- subset(aq.dat.sub, !site.id%in%drop.sites)
    
    #> Sort the dataset by site.id
    aq.dat.sort <- aq.dat[order(aq.dat$site.id),]
    #> Create vector with all site ids for this year. 
    all.sites <- unique(aq.dat.sort$site.id)
    
    #> For each year create a matrix of shuffled indicies for the entire dataset (all sites).  
    #> Transpose the matrix using t() so that each column is a different permuation of the index 1:nrow(aq.dat).
    shuffle.days.sample <- NULL
    print(paste("Shuffling indices for ",length(all.sites),"sites for year", YYYY))
    for(s in all.sites){
      n.days.s <- nrow(subset(aq.dat.sort,site.id==s))
      first.row.num.s <- row(aq.dat.sort)[aq.dat.sort$site.id==s,1][1]
      shuffleSet.s <- t(shuffleSet(n.days.s,n.samples)) + (first.row.num.s-1)
      shuffle.days.sample <- rbind(shuffle.days.sample,shuffleSet.s) 
    }
    name <- assign(paste0("shuffle.days.sample"), shuffle.days.sample) #,YYYY),shuffle.days.sample)
    print(((proc.time() - ptm0)[3])/60)
    mybiglist <- append(mybiglist, name)
    }
    
    #17.22 minuts total  (~1-1.5 min/year)
    
    #Save these permutation indicies so you don't have to wait 17 minutes every time you run the code.
    save(file=paste0(i,"_updated_Data_2020_Permute_Data.Rdata"),
         list=c("shuffle.days.sample.2006","shuffle.days.sample.2007","shuffle.days.sample.2008","shuffle.days.sample.2009",
                "shuffle.days.sample.2010","shuffle.days.sample.2011","shuffle.days.sample.2012","shuffle.days.sample.2013",
                "shuffle.days.sample.2014","shuffle.days.sample.2015","shuffle.days.sample.2016","shuffle.days.sample.2017",
                "shuffle.days.sample.2018"))
    print(file)
  }
  
  rm(list = ls(pattern = "shuffle"))
}

