# -*- coding: utf-8 -*-
"""
Created on Wed Nov  3 00:38:53 2021

@author: KBOAGGIO
"""
import pandas as pd
import os

#%% Function to import the data

def importpm(g): 
    # Import the speciation data
    os.chdir('C:\\Users\\KBoaggio\\OneDrive - Environmental Protection Agency (EPA)\\Wildfire data')
    pm_spec_tot = pd.read_csv(g)
    pm_spec_tot['Arithmetic Mean'] = pm_spec_tot['Arithmetic Mean'].astype(float)
    #pm_spec_tot['Arithmetic Mean'].loc[pm_spec_tot['Arithmetic Mean'] < 0] = 0       # Set negative vals to zero
    pm_spec_tot['Date'] = pd.to_datetime(pm_spec_tot['Date Local'])
    pm_spec_tot['Date'] = pm_spec_tot['Date'].dt.date
    pm_spec_tot.set_index(['Date', 'State Code', 'County Code', 'Site Number', 'POC'], inplace=True)
    pm_spec_tot['Year'] = pd.DatetimeIndex(pm_spec_tot.index.get_level_values('Date')).year

    return pm_spec_tot

#%% Import the speciation linked to HMS plumes data (from Byron code 3.)

spec = importpm('2006-2018 HMS smoke and fire analysis PM2.5 SPEC CA 11-3-2021.csv')

#%% Import PM2.5 measurements and link to data

years = ["2006", "2007", "2008", "2009", "2010", "2011", "2012", "2013", "2014", "2015", "2016", "2017", "2018"]
pm_tot = []
for i in years:
    # Set working directory

    os.chdir('C:\\Users\\KBoaggio\\OneDrive - Environmental Protection Agency (EPA)\\Wildfire data\\AQS files')
    
    pm = pd.read_csv("daily_88101_"+i+".csv")
    pm = pm.rename(columns = {'Site Num': 'Site Number'})
    pm = pm[pm['Sample Duration'].str.contains("24")]
    pm = pm[pm['State Name'] == 'California']
    pm['Date Local'] = pd.to_datetime(pm['Date Local'])
    pm['Date Local'] = pm['Date Local'].dt.date
    pm = pm.rename(columns = {"Date Local":"Date"}) 
    pm.set_index(["Date", "State Code", "County Code", "Site Number"], inplace=True)
    dup_pm = pm[pm.index.duplicated(keep=False)]
    testp = dup_pm.groupby(dup_pm.index)['Arithmetic Mean'].mean()
    pm = pm[~pm.index.duplicated()]
    pm.update(testp)
    
    pm2 = pd.read_csv("daily_88502_"+i+".csv")
    pm2 = pm2.rename(columns = {'Site Num': 'Site Number'})
    pm2 = pm2[pm2['Sample Duration'].str.contains("24")]
    pm2 = pm2[pm2['State Name'] == 'California']
    pm2['Date Local'] = pd.to_datetime(pm2['Date Local'])
    pm2['Date Local'] = pm2['Date Local'].dt.date
    pm2 = pm2.rename(columns = {"Date Local":"Date"}) 
    pm2.set_index(["Date", "State Code", "County Code", "Site Number"], inplace=True)
    dup_pm2 = pm2[pm2.index.duplicated(keep=False)]
    testp2 = dup_pm2.groupby(dup_pm2.index)['Arithmetic Mean'].mean()
    pm2 = pm2[~pm2.index.duplicated()]
    pm2.update(testp2)
    pm2 = pm2[~pm2.index.isin(pm.index.values)]
    
    fire_i = spec[spec['Year'] == int(i)]
    fire_i = fire_i.reset_index().set_index(["Date", "State Code", "County Code", "Site Number"])
    #fire_i = fire_i[~fire_i.index.duplicated()]
    pm_fire_1 = pm[pm.index.isin(fire_i.index.values)] #lead_fire[int(i)-2008].index.values)]
    pm2_fire = pm2[pm2.index.isin(fire_i.index.values)] #lead_fire[int(i)-2008].index.values)]
    pm_fire = pd.concat([pm_fire_1, pm2_fire])
    
    pm_tot.append(fire_i.join(pm_fire, rsuffix='_pm'))

pm_tot = pd.concat(pm_tot)
os.chdir('C:\\Users\\KBoaggio\\OneDrive - Environmental Protection Agency (EPA)\\Wildfire data')
pm_tot.to_csv('2006-2018_pm_speciation_labeled_joined_pm_11_3_21.csv')